{DelphiSim by Roeland van der Spek           }
{spekw@acm.org                               }
{(C) 1997                                    }
{v1.07                                       }
{WaitProcess                                 }

unit waitprocess;

interface

Uses DelphiSim,classes;

type TWaitItem = class(TObject)
       O:TObject;
       T:Double;
       constructor Create(P:Tobject;Time:double);
     end;

     TFOnContinue = Procedure (Load:TObject) of object;

     TWaitProcess = class(TSimprocess)
     private
       waitQ:TSortedList;
       FOnContinue:TFOncontinue;
     protected
       procedure body; override;
     public
       Constructor Create(AOwner:TComponent); override;
       procedure wait(O:TObject;T:Double);
     Published
       property Continue:TFOnContinue Read FOncontinue write FOnContinue;
     end;

procedure register;

implementation

Constructor TWaitItem.Create(P:Tobject;Time:double);
begin
  inherited create;
  O:=P;
  T:=Time;
end;

function Compare(I,J:TObject):Longint;
var P,V:TWaitItem;
begin
  result:=0;
  P:=I as TWaitItem;
  V:=J as TWaitItem;
  if P.T > V.T then result:=1;
  if P.T < V.T then result:=-1;
  IF P.T = V.T then result:=0;
end;

constructor TWaitProcess.Create(AOwner:TComponent);
begin
  inherited create(AOWner);
  WaitQ:=TSortedList.create(Compare);
end;

Procedure TWaitProcess.Wait(O:TObject;T:Double);
var P:TWaitItem;
    index:longint;
begin
  P:=TWaitItem.create(O,T+simTime);
  index:=WaitQ.add(P);
  If index = 0 then ActivateAT(T+SimTime);
end;

Procedure TWaitProcess.body;
var P:TWaitItem;
begin
  if WaitQ.count = 0 then passivate;
  while not false do
  begin
    P:=WaitQ.pop;
    If Assigned(FOnContinue) Then FOnContinue(P.O);
    if WaitQ.count=0 then passivate
    else
    begin
      P:=WaitQ.Items[0];
      HoldUntil(P.T);
    end;
  end;
end;

Procedure Register;
begin
  registercomponents('DelphiSim',[TWaitProcess]);
end;


end.
